package scenegraph;


public class Appearance {
	float[] diffuseColor = {0,0,0,0};
	float[] ambientColor = {0.5f,0.5f,0.5f,0.5f};
	float[] emissiveColor = {0,0,0,0};
	int fillingStyle;
	int shadingStyle;

	// boolean update_requested = true;
	
	int version=0;		// for display list compilation
	void request_update(){
		version++;
	}

	
	public void setDiffuseColor(java.awt.Color color){
		diffuseColor[0] = (float)(color.getRed()/255.0);
		diffuseColor[1] = (float)(color.getGreen()/255.0);
		diffuseColor[2] = (float)(color.getBlue()/255.0);
		diffuseColor[3] = (float)(color.getAlpha()/255.0);
		
		request_update();
		//update_requested = true;
	}
	public void setDiffuseColor(Color color){
		diffuseColor[0] = color.r;
		diffuseColor[1] = color.g;
		diffuseColor[2] = color.b;
		diffuseColor[3] = color.a;
		
		request_update();
		//update_requested = true;
	}
	public void setAmbientColor(Color color){
		ambientColor[0] = color.r;
		ambientColor[1] = color.g;
		ambientColor[2] = color.b;
		ambientColor[3] = color.a;
		
		request_update();
		//update_requested = true;
	}
	public void setEmissiveColor(Color color){
		emissiveColor[0] = color.r;
		emissiveColor[1] = color.g;
		emissiveColor[2] = color.b;
		emissiveColor[3] = color.a;
		
		request_update();
		//update_requested = true;
	}
    
	TextureMap diffuseColorMap;
	public void setDiffuseColorMap( TextureMap map ){
		diffuseColorMap = map;
		
		request_update();
		//update_requested = true;
	}
	
	
	public void setOpacity(double opacity){
		// not yet implemented
		
		request_update();
		//update_requested = true;
	}

	
	
	
	public void setFillingStyle(int style){
		fillingStyle = style;
		
		request_update();
		//update_requested = true;
	}
	public void setShadingStyle(int style){
		shadingStyle = style;
		
		request_update();
		//update_requested = true;
	}
	
	public int getShadingStyle(){
		return shadingStyle;
	}
	public int getFillingStyle(){
		return fillingStyle;
	}
}
