package scenegraph;

import java.awt.*;
import javax.media.opengl.*;
import javax.media.opengl.glu.*;
import java.awt.image.*;
import com.sun.opengl.util.Screenshot;

public class OffscreenRenderTarget {
	Renderer renderer;
	OffscreenRenderTarget(){
	}
	public void addCamera(Camera camera){
		this.camera = camera;
	}
	Camera camera;
	public void setSize(int width, int height){
		this.width = width;
		this.height = height;
	}
	int width;
	int height;
	public void clearAndRenderOffscreen(){
		if (pbuffer == null){
			GLDrawableFactory factory = GLDrawableFactory.getFactory();
			GLCapabilities glcap = new GLCapabilities();
			glcap.setDoubleBuffered(false);
			glcap.setPbufferRenderToTexture(false);
			pbuffer = factory.createGLPbuffer(glcap, null, width, height, null);
		}
		if (context == null)
			context = pbuffer.getContext();
		
		context.makeCurrent();
		
		GL gl = pbuffer.getGL();
		GLU glu = new GLU();
		 
		renderer.display_main(gl, glu, false);
		 
		image = Screenshot.readToBufferedImage(width, height);
		
		//context.release();
	}
	
	GLPbuffer pbuffer;
	GLContext context;
	BufferedImage image;
	
	public Image getOffscreenImage(){
		return image;
	}
	public void release(){
		if (context != null){
			context.destroy();
			context = null;
		}
		if (pbuffer != null){
			pbuffer.destroy();
			pbuffer = null;
		}

	}
	public void copyOffscreenImageToTextureMap(TextureMap textureMap){
		textureMap.setImage(image);
//		context.makeCurrent();
//		GL gl = pbuffer.getGL();

//		gl.glCopyTexImage2D(GL.GL_TEXTURE_2D,0, GL.GL_RGBA, 
//                0,0,width,height, 0, GL.GL_RGBA, gl.GL_UNSIGNED_BYTE,
//				textureMap.texture.getTextureBuffer());

//		context.release();
	}
	
}
