package scenegraph;

import java.awt.*;
import java.awt.event.*;

import javax.vecmath.*;



public class TestFrame extends Frame 
	implements RendererListener, java.awt.event.WindowListener, java.awt.event.ComponentListener,
				MouseListener, MouseMotionListener{
	
	public TestFrame(){
		super();

		addWindowListener( this );
		addComponentListener( this );
		
		setLayout( new java.awt.BorderLayout() );
		setSize( new java.awt.Dimension(600,600));
		
		setVisible(true);
	}
	public void windowActivated( java.awt.event.WindowEvent windowEvent ) {}
	public void windowClosed( java.awt.event.WindowEvent windowEvent ) {}
	public void windowClosing( java.awt.event.WindowEvent windowEvent ) {
		System.exit( 0 );
	}
	public void windowDeactivated( java.awt.event.WindowEvent windowEvent ) {}
	public void windowDeiconified( java.awt.event.WindowEvent windowEvent ) {}
	public void windowIconified( java.awt.event.WindowEvent windowEvent ) {}
	public void windowOpened( java.awt.event.WindowEvent windowEvent ) {
		camera = initSceneGraph();
		initRenderer( camera );
		System.out.println("hello");
	}
	public void componentHidden(java.awt.event.ComponentEvent e){};
	public void componentMoved(java.awt.event.ComponentEvent e){};
	public void componentShown(java.awt.event.ComponentEvent e){};
	public void componentResized(java.awt.event.ComponentEvent e){
		set_camera_parameters();
	};
	public double scale = 0.05;	// 1;
	public void set_camera_parameters(){
		if (camera == null)
			return;
		//camera.setPlane( Double.NaN, -scale, Double.NaN, scale );
	}
	
	
	
	
	
	
	
	Scene scene;
	Transformable cameraVehicle;
	Camera camera;
	public Camera initSceneGraph() {
		scene = new Scene();

		cameraVehicle = new Transformable();
		cameraVehicle.setParent( scene );

		cameraVehicle.setPosition(new Vector3d(0,0,-4));
		//cameraVehicle.rotate(new Vector3d(0,0,1), Math.PI/16);
		camera = new OrthographicCamera();
		//camera = new PerspectiveCamera();
		camera.setParent( cameraVehicle );

		//cameraVehicle.pointAt( scene, new Vector3d(), new Vector3d(0,1,0), cameraVehicle );
		cameraVehicle.setOrientation(new Vector3d(0,0,1), new Vector3d(0,1,0), scene);

		
		AmbientLight ambientLight = new AmbientLight();
		ambientLight.setParent( scene );
		ambientLight.setColor( new Color(74/255.0, 74/255.0, 74/255.0) );

		Transformable sunVehicle = new Transformable();
		sunVehicle.setParent( scene );
		DirectionalLight sunLight = new DirectionalLight();
		sunLight.setColor(new Color(200/255.0, 200/255.0, 200/255.0) );//WHITE );
		sunLight.setParent( sunVehicle );
		sunVehicle.setOrientation( new Vector3d( -1, -1, 3 ), new Vector3d(0,1,0), null );

		
		
		
		createSceneGraph();
		
		//modelVehicle.rotate(new Vector3d(0,0,1), Math.PI/8);
		//modelVehicle.rotate(new Vector3d(0,1,0), Math.PI/16);
		//worldVehicle.setPosition(new Vector3d(1,0,0));
		//modelVehicle.setPosition(new Vector3d(1,1,0));

		//worldVehicle.rotate(new Vector3d(0,0,1), Math.PI/16);

		
		
		
		
		
		return camera;
	}
	public Vector3 getCameraDirection(ReferenceFrame reference){
		Matrix3d axes = cameraVehicle.getAxes( reference );
		return new Vector3(axes.m02, axes.m12, axes.m22);
	}
	
	
	Renderer renderer;
	RenderTarget renderTarget;
	public void initRenderer( Camera camera ) {
		renderer = new Renderer();
		 renderTarget = renderer.createRenderTarget();
		
		Component awtComponent = renderTarget.getAWTComponent();
		add("Center", awtComponent );

		invalidate();
		doLayout();
			
		renderTarget.addCamera( camera );
		renderTarget.addRendererListener( this );
		
		
		awtComponent.addMouseListener(this);
		awtComponent.addMouseMotionListener(this);

	}
	
	public void rendered(Graphics g){
		//g.setColor(java.awt.Color.red);
		//g.fillRect(0,0,100,100);
		
		//renderTarget.repaint();
		//System.out.println("hello");
	}
	
	
	Transformable modelVehicle;
	Transformable worldVehicle;
	public void createSceneGraph(){

		worldVehicle = new Transformable();
		worldVehicle.setParent(scene);
		
		
		modelVehicle = new Transformable();
		modelVehicle.setParent( worldVehicle );
		Visual modelVisual = new Visual();
		modelVisual.setParent( modelVehicle );
		IndexedTriangleArray modelITA = createBallITA(1);//new IndexedTriangleArray();
		modelVisual.setGeometry( modelITA );
		Appearance modelAppearance = new Appearance();
		modelVisual.setFrontFacingAppearance(modelAppearance);
		
		modelAppearance.setDiffuseColor(new Color(0.5,0.5,0.5));//
		modelAppearance.setFillingStyle(FillingStyle.SOLID);//SOLID);//
		modelAppearance.setShadingStyle(ShadingStyle.SMOOTH);//

		try{ 
			TextureMap textureMap = new TextureMap();
			textureMap.setImage(TextureMap.loadImage("texture.gif"));
			modelAppearance.setDiffuseColorMap(textureMap);
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	public IndexedTriangleArray createBallITA(double radius){
		
		IndexedTriangleArray ballITA = new IndexedTriangleArray();

		Vector3d center = new Vector3d(0,0,0);
		Vector3d nv = new Vector3d(0,0,0);
		Vertex3d[] ballVertices = new Vertex3d[2+3*8];
		int n=0;
		for(int y=0; y<5; y++){
			double yangle = Math.PI*2*y/8;
			double yradius = radius * Math.cos(yangle);
			double xradius = radius * Math.sin(yangle);
			if (y==0 || y==4){
				int i = n++;
				ballVertices[i] = new Vertex3d();
				Vector3d v =	new Vector3d(0, yradius, 0);
				ballVertices[i].position.set(v);
				nv.sub(v, center); nv.normalize();
				ballVertices[i].normal.set(nv);
				ballVertices[i].textureCoordinate0.set((float)v.x, (float)v.y);
		}
			else for(int x=0; x<8; x++){
				double xangle = Math.PI*2*x/8;
				int i = n++;
				ballVertices[i] = new Vertex3d();
				Vector3d v =	new Vector3d(xradius * Math.cos(xangle),
							yradius,
							xradius * Math.sin(xangle));
				ballVertices[i].position.set(v);
				nv.sub(v, center); nv.normalize();
				ballVertices[i].normal.set(nv);
				ballVertices[i].textureCoordinate0.set((float)v.x, (float)v.y);
			}
		}

		
		
		
		
		
		int[] ballIndices = new int[2*8*6 + 2*8*3];

		n=0;
		for(int x=0; x<8; x++){
			ballIndices[n++] = 17+x;
			ballIndices[n++] = 17+((x+1)%8);
			ballIndices[n++] = 25;
					
			ballIndices[n++] = 1+x;
			ballIndices[n++] = 0;
			ballIndices[n++] = 1+((x+1)%8);
		}
			
		for(int y=0; y<2; y++)
			for(int x=0; x<8; x++){
				ballIndices[n++] = 1+y*8+x;
				ballIndices[n++] = 1+y*8+((x+1)%8);
				ballIndices[n++] = 1+y*8+x+8;
					
				ballIndices[n++] = 1+y*8+x+8;
				ballIndices[n++] = 1+y*8+((x+1)%8);
				ballIndices[n++] = 1+y*8+((x+1)%8)+8;
		}
		
		

		ballITA.setVertices(ballVertices);
		ballITA.setIndices(ballIndices);

		return ballITA;
	}

	public void rotate_camera(Point p){
		
		Transformable tmpVehicle = new Transformable();
		tmpVehicle.setParent(scene);
		tmpVehicle.setAbsoluteTransformation(cameraVehicle.getAbsoluteTransformation());
		tmpVehicle.setPosition(new Vector3d(0,0,0), scene);
		cameraVehicle.rotate(new Vector3d(0,1,0), (p.x-prev_x)/100.0, tmpVehicle);//cameraVehicle);
		cameraVehicle.rotate(new Vector3d(1,0,0), (p.y-prev_y)/100.0, tmpVehicle);//cameraVehicle);
		

//		modelVehicle.rotate(new Vector3d(0,1,0), (p.x-prev_x)/100.0, null);
//		modelVehicle.rotate(new Vector3d(1,0,0), (p.y-prev_y)/100.0, null);
//		modelVehicle.rotate(new Vector3d(0,1,0), (p.x-prev_x)/100.0, scene);
//		modelVehicle.rotate(new Vector3d(1,0,0), (p.y-prev_y)/100.0, scene);

		
		prev_x = p.x;
		prev_y = p.y;
		
		renderer.repaint();
		
	}
	int prev_x, prev_y;
	
	public void mousePressed( java.awt.event.MouseEvent mouseEvent ) {
		Point p = mouseEvent.getPoint();
		prev_x = mouseEvent.getX();
		prev_y = mouseEvent.getY();
	}
	public void mouseDragged( java.awt.event.MouseEvent mouseEvent ) {
		Point p = mouseEvent.getPoint();
		rotate_camera(p);
	}	
	public void mouseReleased( java.awt.event.MouseEvent mouseEvent ) {
	}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {
		Vector3d local = screen_coords_to_local_coords(new Vector3d(e.getX(), e.getY(), 0), modelVehicle);
		System.out.println("local coords = "+local.x+" "+local.y+" "+ local.z);
		
		//modelVehicle.setParent(null);
				
		renderTarget.repaint();
//		
//		Vector3d screen = local_coords_to_screen_coords(new Vector3d(0,0,0), modelVehicle);
//		System.out.println("screen coords = "+screen.x+" "+screen.y);
		
		//renderTarget.pick(e.getX(), e.getY());

		
//		
//		OffscreenRenderTarget offscreen = renderer.createOffscreenRenderTarget();
//		offscreen.addCamera(camera);
//		offscreen.setSize(600,600);
//		offscreen.clearAndRenderOffscreen();
//		Image offscreenImage = offscreen.getOffscreenImage();
//		
//		// 摜t@CƂďoꍇ
//		java.awt.image.BufferedImage bufferedImage = new java.awt.image.BufferedImage(600,600, java.awt.image.BufferedImage.TYPE_INT_RGB);
//		Graphics g2 = bufferedImage.getGraphics();
//		g2.drawImage(offscreenImage, 0,0,null);
//		g2.dispose();
//
//		java.io.File file = new java.io.File("hello.png");
//		try{
//			javax.imageio.ImageIO.write(bufferedImage, "png", file);
//		}
//		catch(java.io.IOException ex){System.out.println(""+ex);}
//		
//		offscreen.release();
//		
	}
	public void mouseMoved(MouseEvent e) {}

	
	
	public Vector3d screen_coords_to_local_coords(Vector3d viewportPt, ReferenceFrame reference){
		if (reference == null)
			reference = scene;
		Vector3d cameraPt = new Vector3d(renderTarget.transformFromViewportToCamera(viewportPt, camera));
		return cameraVehicle.transformTo(cameraPt, reference);
	}	
	public Vector3 local_coords_to_screen_coords(Vector3d localPt, ReferenceFrame  targetVehicle){

		Vector3d cameraPt = targetVehicle.transformTo(localPt, cameraVehicle);
		return new Vector3(renderTarget.transformFromCameraToViewport(cameraPt, camera));
	}
	
	  public static void main(String[] args) {
		new TestFrame();
	}
	
}
