package scenegraph;

import java.awt.*;
import java.awt.image.*;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.imageio.ImageIO;
import java.util.*;
public class TextureMap {
	BufferedImage image;
	public void setImage( Image image ){
		if (image instanceof BufferedImage){
			this.image = (BufferedImage) image;
			return;
		}
		PixelGrabber pixelGrabber = new PixelGrabber(image, 0, 0, -1, -1, false);
		try{
			pixelGrabber.grabPixels();
		}
		catch(Exception e){
			e.printStackTrace();
		}
		ColorModel cm = pixelGrabber.getColorModel();

		final int w = pixelGrabber.getWidth();
		final int h = pixelGrabber.getHeight();
		WritableRaster raster = cm.createCompatibleWritableRaster(w, h);
		BufferedImage renderedImage =
		  new BufferedImage(
		    cm,
		    raster,
		    cm.isAlphaPremultiplied(),
		    new Hashtable());
		renderedImage.getRaster().setDataElements(0, 0, w, h, pixelGrabber.getPixels());

		this.image = renderedImage;
	}
	public static final int RGBA = 0; 
	public void setFormat(int format){
		// not yet implemented
	}
	public int textureID = -1;
	
	public Image getImage(){
		return image;
	}
	
	static public BufferedImage loadImage(String ref) throws Exception
	{
		File file = new File(ref);

		if (!file.isFile()) {
			throw new IOException("Cannot find: "+ref);
		}
		ImageIO.setUseCache(false);
		BufferedImage bufferedImage =
				ImageIO.read(new BufferedInputStream(new FileInputStream(file)));

		if(bufferedImage == null)
			throw new Exception("BufferedImage null after loadImage()");

		return bufferedImage;

	} // end loadImage	
	
	
}
